/*2013.9
************************************************
**        Time measure using TDC&PIC16F73    **
************************************************
*/
#include <pic.h>
#include <stdio.h>

__CONFIG(0x3F36);				//WDTӳ

#define uchar unsigned char
#define uint unsigned int
#define SS RA5
#define SDO RC5
#define SDI RC4
#define SCK RC3
#define SPI_En() (RA5=0)
#define SPI_Di() (RA5=1)
//#define Tref 250				//250ns@4MHz
//#define N 1					//ڲʱӷƵ
#define _XTAL_FREQ 4000000UL	//ʱ4MHzʱ

/**********************global variable definition***************************/
//uchar disp_data;				//洢ʾȫֱ 
uint time=0;					//ʱ
bit neganum=0;					//ʱֵ־λ

/************************function declaration*******************************/
void init();					//ʼ
void init_display();			//λʾʼ
void display();					//ʾ λʾʱ λΪns
void init_TDC();				//TDCʼ624λĴ
uchar spi_transmit(uchar data);	//SPIݴ䣨ݴ䣬Ȼȴͽ󷵻SSPBUFֵʱʹã
uint read();					//fushuTDCʱ
void write_data(uchar addr,uchar wdata1,uchar wdata2,uchar wdata3);	//дTDC24λĴ
void write_opcode(uchar addr);	//TDCĴд
uint invert(uchar m);			//תʮƺ
void bit_display_posi(uchar m);	//λʾ
void bit_display_nega(uchar m);	//λʾ

/**********************interrupt service code*******************************/
void interrupt ISR()
{
	if(INTE&&INTF)				//RB0ⲿжϷ
	{
		INTE=0;
		INTF=0;					//RB0/INTⲿжϱ־λ
		time=read();
		write_opcode(0x70);		//͡InitʼGP2ԱTDCܹStartStopź
		INTE=1;
	}
}

/************************main function************************************/ 
void main()
{
	__delay_ms(100);
	init();
	init_display();
	write_opcode(0x50);		//power on reset
	__delay_ms(200);
	init_TDC();				//ʼTDC
	write_opcode(0x07);		//͡InitʼGP2ԱTDCܹStartStopź
	while(1)
	{
		CLRWDT();			//ι
		display();
		__delay_us(50);
	}
}

void init()					//ʼ
{
	ADCON1=0x06;			//RAΪֿ
	TRISA=0x00;				//ȫΪ
	TRISB=0x01;				//RB0ΪжڣΪ
	TRISC=0x10;				//RC4(SDI)Ϊ,Ϊ
	OPTION_REG=0x00;		//RB0ж½ش
	PSA=1;					//TIMER0/WDTԤƵWDT
	PS2=1;					//128Ƶ,128*18msԼ2.3s
	PS1=1;								
	PS0=1;
	//SSPCON=0x22;			//00100010SSPEN=1ʹܴж˿ڣCKP=0״̬ʱʱΪ͵ƽģʽ ʱ=Fosc/64	
	//SSPSTAT=0x40;			//01000000,SMP=0,CKE=1
	//SPIʼ
	SSPEN=1;				//ʹܴнӿڣSCKSDOSDISSΪ
	CKP=0;					//ʱΪ͵ƽ
	SMP=0;					//ʱм
	CKE=0;					//SCKش
	SSPM3=SSPM2=SSPM1=SSPM0=0;//SPIģʽʱΪFosc/4
	SPI_Di();				//ʼʱֹSPI
	GIE=1;					//ȫж
	PEIE=1;					//ʹⲿж
	INTE=1;					//RB0/INTⲿжλ
}

void init_display()		//λʾʼ
{
	ADCON1=0x06;			//RAΪֿ
	TRISA=0x00;				//ȫΪ
	TRISB=0x01;				//RB0ΪжڣΪ
	TRISC=0x10;				//RC4(SDI)Ϊ,Ϊ
	PORTC=0x07;				//λѡ
	PORTB=0x00;				//ȫʾ0
	PORTA=0x23;
}


void init_TDC()			//TDCʼд624λĴ
{
	write_data(0X00,0X00,0X05,0X10);	//startstopЧΧ1ԶУ׼
	write_data(0X01,0X19,0Xc9,0X00);	//1.stop Ch2-1.stop Ch1
	write_data(0X02,0X00,0X00,0X00);
	write_data(0X03,0X18,0X00,0X00);
	write_data(0X04,0X20,0X00,0X00);
	write_data(0X05,0X18,0X00,0X00);
}

uchar spi_transmit(uchar data)	//SPIݴ
{
	SSPBUF=data;
	while(!BF);
	return SSPBUF;
}

uint read()		//TDCʱ
{
	uint time=0;
	uchar read_temp[2];
	uint temp1;
	uint temp2; 
	float read_data;
	SPI_En();
	asm("nop");
	spi_transmit(0xB0);			//Χ1δУ׼16λ2Ʋ
	read_temp[0]=spi_transmit(0x00);
	read_temp[1]=spi_transmit(0x00);
	asm("nop");
	SPI_Di();
	asm("nop");
	if((read_temp[0]&0x80)==0)	//ʱΪ
	{
		neganum=0;
		temp1=invert(read_temp[0]);
		temp2=invert(read_temp[1]);
		read_data=temp1*256+temp2;
	}
	else						//ʱΪ
	{
		neganum=1;
		read_temp[0]=read_temp[0]^0xff;	//λȡ
		temp1=invert(read_temp[0])+1;	//Ʋ븺ȡһ
		temp2=invert(read_temp[1]);
		read_data=temp1*256+temp2;
	}
	time=(uint)(read_data*0.065);		//У׼Time=RES_X*LBS=RES_X*65ps,λΪns
	return (time);
}

void write_data(uchar addr,uchar wdata1,uchar wdata2,uchar wdata3)	//TDCд
{
	SPI_En();
	asm("nop");
	spi_transmit(0x80|addr);
	spi_transmit(wdata1);
	//asm("nop");
	spi_transmit(wdata2);
	//asm("nop");
	spi_transmit(wdata3);
	asm("nop");
	SPI_Di();
	asm("nop");
}

void write_opcode(uchar addr)//TDCд
{
	SPI_En();
	asm("nop");
	spi_transmit(addr);
	asm("nop");
	SPI_Di();
	asm("nop");
}

uint invert(uchar m)		//תʮƺ
{
	uint t=0;
	if(m&0x80)
		t+=128;
	if((m<<=1)&0x80)
		t+=64;
	if((m<<=1)&0x80)
		t+=32;
	if((m<<=1)&0x80)
		t+=16;
	if((m<<=1)&0x80)
		t+=8;
	if((m<<=1)&0x80)
		t+=4;
	if((m<<=1)&0x80)
		t+=2;
	if((m<<=1)&0x80)
		t+=1;
	return(t);
}

void display()			//ʾ λʾʱ λΪns
{//λƣĩλDPʾĻĻʾΧʾ---
	uchar num[3];
	if((time>999)&&(time<-999))	//ʾΧ
	{
		RC0=1;
		bit_display_posi(11);
		RC1=1;
		bit_display_posi(11);
		RC2=1;
		bit_display_posi(11);
	}
	else						//λʾΧ
	{
		num[2]=(uchar)(time/100);
		num[1]=(uchar)((time%100)/10);
		num[0]=(uchar)(time%10);
		if(neganum==1)			//ʾ
		{
			RC0=1;
			bit_display_nega(num[2]);
			RC1=1;
			bit_display_nega(num[1]);
			RC2=1;
			bit_display_nega(num[0]);
		}
		else					//ʾ
		{
			RC0=1;
			bit_display_posi(num[2]);
			RC1=1;
			bit_display_posi(num[1]);
			RC2=1;
			bit_display_posi(num[0]);
		}
	}
}

void bit_display_nega(uchar m)			//λʾ
{
	switch(m)
	{
		case 0:PORTB=0x80;RA0=0;break;
		case 1:PORTB=0x9E;RA0=0;break;
		case 2:PORTB=0x42;RA0=0;break;
		case 3:PORTB=0x0A;RA0=0;break;
		case 4:PORTB=0x1C;RA0=0;break;
		case 5:PORTB=0x08;RA0=1;break;
		case 6:PORTB=0x00;RA0=1;break;
		case 7:PORTB=0x9A;RA0=0;break;
		case 8:PORTB=0x00;RA0=0;break;
		case 9:PORTB=0x08;RA0=0;break;
		//case 0BA:PORTB=0x10;RA0=0;break;
		//case 0BB:PORTB=0x;RA0=;break;
		//case 0BC:PORTB=0x;RA0=;break;
		//case 0BD:PORTB=0x;RA0=;break;
		//case 0BE:PORTB=0x;RA0=;break;
		//case 0BF:PORTB=0x;RA0=;break;
		default:PORTB=0x7E,RA0=0;
	}	
}

void bit_display_posi(uchar m)			//λʾ
{
	switch(m)
	{
		case 0:PORTB=0xA0;RA0=0;break;
		case 1:PORTB=0xBE;RA0=0;break;
		case 2:PORTB=0x62;RA0=0;break;
		case 3:PORTB=0x2A;RA0=0;break;
		case 4:PORTB=0x3C;RA0=0;break;
		case 5:PORTB=0x28;RA0=1;break;
		case 6:PORTB=0x20;RA0=1;break;
		case 7:PORTB=0xAA;RA0=0;break;
		case 8:PORTB=0x20;RA0=0;break;
		case 9:PORTB=0x28;RA0=0;break;
		//case 0BA:PORTB=0x;RA0=;break;
		//case 0BB:PORTB=0x;RA0=;break;
		//case 0BC:PORTB=0x;RA0=;break;
		//case 0BD:PORTB=0x;RA0=;break;
		//case 0BE:PORTB=0x;RA0=;break;
		//case 0BF:PORTB=0x;RA0=;break;
		default:PORTB=0x7E,RA0=0;
	}	
}
